#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define N		10				/* N */
#define EPS		pow(10.0, -8.0)	/* epsilon̐ݒ */
#define KMAX	100

/* s̓ */
void input_matrix(double **a, char c, FILE* fin, FILE* fout);
/* xNg̓ */
void input_vector(double *b, char c, FILE* fin, FILE* fout);
/* s̗̈m */
double **dmatrix(int nr1, int nr2, int nl1, int nl2);
/* s̗̈@ */
void free_dmatrix(double** a, int nr1, int nr2, int nl1, int nl2);
/* xNg̈̊m */
double* dvector(int i, int j);
/* xNg̗̈@ */
void free_dvector(double* a, int i);
/* r֐ */
int double_comp(const void *s1, const void *s2);
/* őlm̌vZ@a[m...n] */
double vector_norm_max(double *a, int m, int n);
/* KEXEUCf@ */
double* gauss_seidel(double** a, double* b, double* x);

/* s̓ */
void input_matrix(double **a, char c, FILE* fin, FILE* fout) {
	int i, j;
	fprintf(fout, "s%c͎̒ʂł\n", c);
	for (i = 1; i <= N; ++i) {
		for (j = 1; j <= N; ++j) {
			fscanf(fin, "%lf", &(a[i][j]));
			fprintf(fout, "%5.2f\t", a[i][j]);
		}
		fprintf(fout, "\n");
	}
}

/* xNg̓ */
void input_vector(double *b, char c, FILE* fin, FILE* fout) {
	int i;
	fprintf(fout, "xNg%c͎̒ʂł\n", c);
	for (i = 1; i <= N; ++i) {
		fscanf(fin, "%lf", &(b[i]));
		fprintf(fout, "%5.2f\t", b[i]);
		fprintf(fout, "\n");
	}
}

/* s̗̈m */
double** dmatrix(int nr1, int nr2, int nl1, int nl2)
{
	int i, nrow, ncol;
	double** a;

	nrow = nr2 - nr1 + 1; /* s̐ */
	ncol = nl2 - nl1 + 1; /* ̐ */

	/* s̊m */
	if ((a = malloc(nrow * sizeof(double*))) == NULL)
	{
		printf("mۂł܂isaj\n");
		exit(1);
	}
	a = a - nr1; /* s炷 */

	/* ̊m */
	for (i = nr1; i <= nr2; ++i) a[i] = malloc(ncol * sizeof(double)); 
	/* for (i = 0; i < nrow; ++i) a[i] = malloc(ncol * sizeof(double)); */
	for (i = nr1; i <= nr2; i++) a[i] = a[i] - nl1; 

	return a;
}

/* s̗̈@ */
void free_dmatrix(double** a, int nr1, int nr2, int nl1, int nl2) 
{
	int i;

	/* ̉@@*/
	for (i = nr1; i <= nr2; ++i) free((void*)(a[i] + nl1)); 
	free((void*)(a + nr1)); 
}


/* xNg̈̊m */
double* dvector(int i, int j) /* a[i]`a[j]̗̈m */
{
	double* a;

	if ((a = malloc(((j - i + 1) * sizeof(double)))) == NULL)
	{
		printf("mۂł܂ifrom dvectorj\n");
		exit(1);
	}

	return(a - i);
}

/* xNg̗̈@ */
void free_dvector(double* a, int i)
{
	free((void*)(a + i)); /* (void *)^ւ̃LXgKv@*/
}

/* r֐ */
int double_comp(const void *s1, const void *s2)
{
	const double a1 = *((double*)s1); /* (double*)փLXg */
	const double a2 = *((double*)s2); /* (double*)փLXg */

	if (a1 < a2)
	{
		return -1;
	}
	else if (a1 == a2)
	{
		return 0;
	}
	else
	{
		return 1;
	}
}

/* őlm̌vZ@a[m...n] */
double vector_norm_max(double *a, int m, int n)
{
	int i, tmp;
	tmp = n - m - 1; /* Svf̌vZ */

	for (i = m; i <= n; i++) a[i] = fabs(a[i]);

	/* בւF擪AhXmĂ邱ɒ */
	qsort(a + m, tmp, sizeof(a[0]), double_comp);

	return a[n];
}

int main(void)
{
	FILE* fin, * fout;
	double** a, * b, * x;
	int i;

	/* s񂨂уxNg̗̈m */
	a = dmatrix(1, N, 1, N); /* s a[l. . .N] [1. . .N] */
	b = dvector(1, N); /* b[l...N] */
	x = dvector(1, N); /* x[l...N] */

	/* t@C̃I[v */

	if ((fin = fopen("input_sp.dat", "r")) == NULL)
	{
		printf("t@C܂ : input_sp.dat \n");
		exit(1);
	}
	if ((fout = fopen("output_sp.dat", "w")) == NULL)
	{
		printf("t@C쐬ł܂ : output_sp.dat \n");
		exit(1);
	}

	input_matrix(a, 'A', fin, fout); /* sA̓o */
	input_vector(b, 'b', fin, fout); /* xNgb̓o */
	input_vector(x, 'x', fin, fout); /* xNgx0̓o */
	x = gauss_seidel(a, b, x);

	/* ʂ̏o */
	fprintf(fout, "Ax=b ͎̉̒ʂł\n");
	for (i = 1; i <= N; i++)
	{
		fprintf(fout, "%f\n", x[i]);
	}

	fclose(fin); fclose(fout); /* t@C̃N[Y */

	/* ̈̉@ */
	free_dmatrix(a, 1, N, 1, N); free_dvector(b, 1); free_dvector(x, 1);

	return 0;
}

/* KEXEUCf@ */
double* gauss_seidel(double** a, double* b, double* x)
{
	double eps, * xo, s, t;
	int i, j, k = 0;
	xo = dvector(1, N); /* xo[1...N] */

	do
	{
		/* xo <- x_k, x <- x_{k+1} */
		for (i = 1; i <= N; i++) xo[i] = x[i]; /* x_kx_(k+1) */
		/* i=1̏ */
		t = 0.0; 
		for (j = 2; j <= N; j++) t += a[1][j] * xo[j];
		x[1] = (b[1] - t) / a[1][1];
		/* i=2,3, . . .N ̏ */
		for (i = 2; i <= N; i++)
		{
			s = 0.0; t = 0.0;
			for (j = 1; j < i; j++) s += a[i][j] * x[j];	/* i-1܂ł̘a */
			for (j = i+1; j <= N; j++) t += a[i][j] * x[j];	/* i+1ȍ~̘a */
			x[i] = (b[i] - s - t) / a[i][i];
		}
		for (i = 1; i <= N; i++) xo[i] = xo[i] - x[i];
		eps = vector_norm_max(xo, 1, N);
		k++;
	} while (eps > EPS && k < KMAX);
	free_dvector(xo, 1); /* */
	if (k == KMAX)
	{
		printf("݂͂܂ł\n");
		exit(1);
	}
	else
	{
		printf("񐔂%dł\n", k); /* 񐔂ʂɕ\ */ 
		return x;
	}
}